Index: .gitignore
===================================================================
--- .gitignore	(revision d2f75eb31efa7109d60f52eb578fddc21c8d1e2d)
+++ .gitignore	(revision 72c72d4a367ffdd08c3e7633b0240d085bd83925)
@@ -1,34 +1,24 @@
+*.a
+*.check.c
+*.d
+*.deflate
 *.disasm
-*.deflate
-*.a
-*.o
 *.la
 *.lo
 *.map
+*.o
 *.prev
+*.pyc
 *.so.*
-*.d
-*.pyc
-*.check.c
-tag
-tags
-common.h.new
-deps.mk
+/Makefile.common
 /Makefile.config
-/Makefile.common
-autotool/
-boot/distroot/
-boot/initrd.img
 /common.h
 /config.h
 /cscope.out
-doxygen/doxygen.cfg
-doxygen/doxygen.cfg.gen
-doxygen/html/
-doxygen/latex/
 /hdisk.img
+/image.boot
 /image.iso
 /uImage.bin
-/image.boot
+autotool/
 boot/arch/arm32/_link.ld
 boot/arch/ia64/_link.ld
@@ -40,7 +30,16 @@
 boot/components.zip
 boot/components_desc.c
+boot/distroot/
 boot/image.bin
 boot/image.boot
 boot/image.raw
+boot/initrd.img
+common.h.new
+deps.mk
+doxygen/doxygen.cfg
+doxygen/doxygen.cfg.gen
+doxygen/html/
+doxygen/latex/
+kernel/arch/abs32le/_link.ld
 kernel/arch/amd64/_link.ld
 kernel/arch/arm32/_link.ld
@@ -50,9 +49,26 @@
 kernel/arch/ppc32/_link.ld
 kernel/arch/sparc64/_link.ld
-kernel/arch/abs32le/_link.ld
 kernel/generic/src/debug/real_map.bin
 kernel/kernel.bin
 kernel/kernel.dump
 kernel/kernel.raw
+tag
+tags
+tools/amd64-unknown-elf
+tools/arm-linux-gnueabi
+tools/binutils-*.tar.bz2
+tools/downloads/
+tools/gcc-*.tar.bz2
+tools/gdb-*.tar.gz
+tools/i686-pc-linux-gnu
+tools/ia64-pc-linux-gnu
+tools/mips-linux-gnu
+tools/mips64el-linux-gnu
+tools/mipsel-linux-gnu
+tools/ppc-linux-gnu
+tools/ppc64-linux-gnu
+tools/riscv64-unknown-linux-gnu
+tools/sparc64-linux-gnu
+tools/sycek/
 uspace/app/barber/barber
 uspace/app/barber/images.c
@@ -130,4 +146,5 @@
 uspace/app/vlaunch/images_desc.c
 uspace/app/vlaunch/vlaunch
+uspace/app/vol/vol
 uspace/app/vterm/vterm
 uspace/app/vuhid/vuh
@@ -135,4 +152,5 @@
 uspace/app/websrv/websrv
 uspace/app/wifi_supplicant/wifi_supplicant
+uspace/dist/app/
 uspace/dist/app/barber
 uspace/dist/app/bdsh
@@ -206,4 +224,5 @@
 uspace/dist/demo.wav
 uspace/dist/demo.xm
+uspace/dist/drv/
 uspace/dist/drv/ahci/
 uspace/dist/drv/apic/
@@ -217,6 +236,6 @@
 uspace/dist/drv/i8042/
 uspace/dist/drv/i8259/
+uspace/dist/drv/icp-ic/
 uspace/dist/drv/icp/
-uspace/dist/drv/icp-ic/
 uspace/dist/drv/isa/
 uspace/dist/drv/kfb/
@@ -248,12 +267,10 @@
 uspace/dist/drv/vhc/
 uspace/dist/drv/virt/
+uspace/dist/drv/xhci/
 uspace/dist/drv/xtkbd/
-uspace/dist/drv/xhci/
+uspace/dist/inc/
 uspace/dist/inc/_link.ld
 uspace/dist/inc/c/
 uspace/dist/logo.tga
-uspace/dist/app/
-uspace/dist/drv/
-uspace/dist/inc/
 uspace/dist/srv/
 uspace/dist/test/
@@ -275,6 +292,6 @@
 uspace/drv/bus/usb/usbmid/usbmid
 uspace/drv/bus/usb/vhc/vhc
+uspace/drv/bus/usb/xhci/test-xhci
 uspace/drv/bus/usb/xhci/xhci
-uspace/drv/bus/usb/xhci/test-xhci
 uspace/drv/char/i8042/i8042
 uspace/drv/char/msim-con/msim-con
@@ -289,7 +306,7 @@
 uspace/drv/hid/adb-mouse/adb-mouse
 uspace/drv/hid/atkbd/atkbd
-uspace/drv/hid/xtkbd/xtkbd
 uspace/drv/hid/ps2mouse/ps2mouse
 uspace/drv/hid/usbhid/usbhid
+uspace/drv/hid/xtkbd/xtkbd
 uspace/drv/intctl/apic/apic
 uspace/drv/intctl/i8259/i8259
@@ -301,4 +318,5 @@
 uspace/drv/nic/rtl8139/rtl8139
 uspace/drv/nic/rtl8169/rtl8169
+uspace/drv/nic/virtio-net/virtio-net
 uspace/drv/platform/amdm37x/amdm37x
 uspace/drv/platform/icp/icp
@@ -316,4 +334,8 @@
 uspace/drv/test/test3/test3
 uspace/drv/time/cmos-rtc/cmos-rtc
+uspace/lib/c/arch/abs32le/_link-dlexe.ld
+uspace/lib/c/arch/abs32le/_link-loader.ld
+uspace/lib/c/arch/abs32le/_link-shlib.ld
+uspace/lib/c/arch/abs32le/_link.ld
 uspace/lib/c/arch/amd64/_link-dlexe.ld
 uspace/lib/c/arch/amd64/_link-loader.ld
@@ -348,8 +370,4 @@
 uspace/lib/c/arch/sparc64/_link-shlib.ld
 uspace/lib/c/arch/sparc64/_link.ld
-uspace/lib/c/arch/abs32le/_link-dlexe.ld
-uspace/lib/c/arch/abs32le/_link-loader.ld
-uspace/lib/c/arch/abs32le/_link-shlib.ld
-uspace/lib/c/arch/abs32le/_link.ld
 uspace/lib/c/test-libc
 uspace/lib/label/test-liblabel
@@ -408,18 +426,2 @@
 uspace/srv/vfs/vfs
 uspace/srv/volsrv/volsrv
-tools/amd64-unknown-elf
-tools/arm-linux-gnueabi
-tools/i686-pc-linux-gnu
-tools/ia64-pc-linux-gnu
-tools/mips-linux-gnu
-tools/mips64el-linux-gnu
-tools/mipsel-linux-gnu
-tools/ppc-linux-gnu
-tools/ppc64-linux-gnu
-tools/riscv64-unknown-linux-gnu
-tools/sparc64-linux-gnu
-tools/binutils-*.tar.bz2
-tools/gcc-*.tar.bz2
-tools/gdb-*.tar.gz
-tools/sycek/
-tools/downloads/